#include <stdlib.h>
#include <iostream>
#include <vector>
#include <fstream>
#include <string>
using namespace std;

/* Can only be used with arrays defined with a specific number of elements
 * at definition time. Rather useless in other words. 
 * E.g., works with "int x[10];", but not "int *x; x = (int)malloc(sizeof(int)*10));" */
#define ARSIZE(a)	(sizeof(a)/sizeof(a[0]))
#define MAXY	1024
#define MAXX	1024

struct coord {
	int x, y;
	bool set;
};

class Group {
	public: 
		Group();
	//	struct coord *allingroup();
		bool addgroup(int x, int y);
		bool ingroup(int x, int y);
		void printgroup(int sizey);
	private:	
		vector<coord> coordsInGroup;
};

class goboard {
        public:
                int readboard(char *file);
                int findgroups();
		int printboard();
                int printgroups(); 
        private:
		int ingroup(int x, int y);
		vector<Group> groups;
		int board[MAXX][MAXY];
		unsigned int sizeX, sizeY;
};

